/* 页面加载动画 */
.ele-admin-loading {
  width: 28px;
  height: 28px;
  display: grid;
  grid-gap: 8px;
  grid-template-rows: repeat(2, 1fr);
  grid-template-columns: repeat(2, 1fr);
  transform: rotate(45deg);
  animation: loadingRotate 1.2s infinite linear;
  position: fixed;
  top: calc(50% - 14px);
  left: calc(50% - 14px);
}

.ele-admin-loading > i {
  border-radius: 50%;
  background: #2f54eb;
}

.ele-admin-loading > i:nth-child(2) {
  opacity: 0.7;
}

.ele-admin-loading > i:nth-child(3) {
  opacity: 0.5;
}

.ele-admin-loading > i:nth-child(4) {
  opacity: 0.3;
}

@keyframes loadingRotate {
  to {
    transform: rotate(405deg);
  }
}

/* 路由切换动画 */
/* 渐变 */
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.2s ease-in-out;
}

.fade-enter-from,
.fade-leave-to {
  opacity: 0;
}

/* 底部消退 */
.slide-bottom-enter-active,
.slide-bottom-leave-active {
  transition:
    opacity 0.2s ease-out,
    transform 0.25s ease-out;
}

.slide-bottom-enter-from {
  opacity: 0;
  transform: translateY(-10%);
}

.slide-bottom-leave-to {
  opacity: 0;
  transform: translateY(10%);
}

/* 右侧消退 */
.slide-right-leave-active,
.slide-right-enter-active {
  transition:
    opacity 0.2s ease-out,
    transform 0.25s ease-out;
}

.slide-right-enter-from {
  opacity: 0;
  transform: translateX(-60px);
}

.slide-right-leave-to {
  opacity: 0;
  transform: translateX(60px);
}

/* 放大渐变 */
.zoom-in-enter-active,
.zoom-in-leave-active {
  transition:
    opacity 0.2s ease-out,
    transform 0.25s ease-out;
}

.zoom-in-enter-from {
  opacity: 0;
  transform: scale(0.8);
}

.zoom-in-leave-to {
  opacity: 0;
  transform: scale(1.2);
}

/* 缩小渐变 */
.zoom-out-leave-active,
.zoom-out-enter-active {
  transition:
    opacity 0.2s ease-out,
    transform 0.25s ease-out;
}

.zoom-out-enter-from {
  opacity: 0;
  transform: scale(1.2);
}

.zoom-out-leave-to {
  opacity: 0;
  transform: scale(0.8);
}

/* 主题切换过渡 */
::view-transition-old(root),
::view-transition-new(root),
::view-transition-old(body),
::view-transition-new(body) {
  animation: none;
  mix-blend-mode: normal;
}

::view-transition-new(root),
html.ele-theme-dark::view-transition-old(root),
html.ele-admin-weak::view-transition-old(root),
html.ele-theme-dark.ele-admin-weak::view-transition-new(root),
::view-transition-new(body) {
  z-index: 1;
}

::view-transition-old(root),
html.ele-theme-dark::view-transition-new(root),
html.ele-admin-weak::view-transition-new(root),
html.ele-theme-dark.ele-admin-weak::view-transition-old(root),
::view-transition-old(body) {
  z-index: 2147483646;
}

html.disabled-transition,
html.disabled-transition body,
html.disabled-transition :not(.view-transition-trigger) * {
  transition: none !important;
}

html.disabled-transition {
  background: var(--ele-color-primary);
}

html.ele-theme-dark {
  color-scheme: dark;
}

:root {
  color-scheme: light;
}

body {
  font-family:
    -apple-system, BlinkMacSystemFont, Roboto, Arial, Helvetica, 'Segoe UI',
    'Noto Sans', sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji',
    'Segoe UI Symbol', 'Noto Color Emoji';
  background-attachment: fixed;
  overflow-x: hidden;
}

/* 色弱模式 */
.ele-admin-weak {
  filter: invert(0.8) brightness(1.2) contrast(1.6);
}

.ele-admin-weak.ele-theme-dark {
  filter: invert(0.8) contrast(1.92);
}

/* 全局页脚 */
.ele-footer-fixed {
  flex-shrink: 0;
  height: 38px;
  display: flex;
  align-items: center;
  box-sizing: border-box;
  font-size: 13px;
  color: var(--ele-text-color-secondary);
  padding: 0 14px;
  background: var(--ele-bg-color);
  border: 0px solid var(--ele-border-color-lighter);
  border-top-width: 1px;
  z-index: var(--ele-layout-index);
}

.ele-footer-fixed > div:first-child {
  flex: 1;
  white-space: nowrap;
  word-break: break-all;
  text-overflow: ellipsis;
  overflow: hidden;
}

.ele-footer-fixed + .ele-admin-iframe-wrap {
  bottom: 38px;
}

.ele-footer-fixed a {
  color: var(--ele-text-color-secondary);
}

.ele-footer-fixed a:hover {
  color: #2f54eb;
}

/* 退出内容全屏按钮 */
.ele-layout-fullscreen-icon {
  width: 28px;
  height: 28px;
  color: #fff;
  font-size: 15px;
  border-radius: 0 0 0 100%;
  background: hsla(0, 0%, 40%, 0.8);
  box-shadow: 0 0 2px 0 rgba(255, 255, 255, 0.6);
  justify-content: flex-end;
  align-items: flex-start;
  padding: 4px 4px 0 0;
  box-sizing: border-box;
  transition: all 0.3s ease-out;
  z-index: 180;
  position: fixed;
  top: 0;
  right: 0;
  cursor: pointer;
}

.ele-layout-fullscreen-icon:hover {
  background: hsla(0, 0%, 60%, 0.8);
}

/* 暗色和主色顶栏下暗黑主题切换开关颜色调整 */
.ele-admin-header.is-dark .ele-dark-switch > div {
  --ele-border-color: transparent;
  --ele-fill-color: rgba(255, 255, 255, 0.2);
}

.ele-admin-header.is-primary .ele-dark-switch > div {
  --ele-border-color: transparent;
  --ele-fill-color: rgba(255, 255, 255, 0.38);
}

/* 主色顶栏 logo 增加白色滤镜 */
.ele-admin-header.is-primary .ele-admin-logo img,
.ele-admin-sidebar.is-primary .ele-admin-logo img,
.ele-admin-sidebox.is-primary .ele-admin-logo img {
  filter: contrast(0%) brightness(1000%);
}

/* 卡片风格布局 */
.layout-card-style.ele-admin-layout.ele-pro-layout
  > .ele-admin-main
  > .ele-admin-header {
  border-radius: 8px;
  margin: 14px 14px 0 14px;
}

.layout-card-style.ele-admin-layout.ele-pro-layout
  > .ele-admin-main
  > .ele-admin-header.show-divider {
  border-radius: 8px 8px 0 0;
}

.layout-card-style.ele-admin-layout.ele-pro-layout
  > .ele-admin-main
  > .ele-admin-body
  > .ele-admin-tabs:not(.is-button) {
  border-radius: 0 0 8px 8px;
  width: calc(100% - 28px);
  margin-right: auto;
  margin-left: auto;
}

.layout-card-style.ele-admin-layout.ele-pro-layout
  > .ele-admin-main
  > .ele-admin-body
  > .ele-admin-wrapper
  > .ele-footer-fixed {
  margin: 0 14px 0 14px;
  border-radius: 8px 8px 0 0;
  border-left-width: 1px;
  border-right-width: 1px;
}

.layout-card-style.ele-admin-layout.ele-pro-layout
  > .ele-admin-header.is-primary
  > .ele-admin-tabs.is-simple,
.layout-card-style.ele-admin-layout.ele-pro-layout
  > .ele-admin-header.is-primary
  > .ele-admin-tabs.is-indicator,
.layout-card-style.ele-admin-layout.ele-pro-layout
  > .ele-admin-main
  > .ele-admin-header.is-primary
  > .ele-admin-tabs.is-simple,
.layout-card-style.ele-admin-layout.ele-pro-layout
  > .ele-admin-main
  > .ele-admin-header.is-primary
  > .ele-admin-tabs.is-indicator {
  --ele-tab-simple-active-bg: var(--ele-layout-bg);
}

.layout-card-style.ele-admin-layout.ele-pro-layout.layout-mix-card-style
  > .ele-admin-side
  > .ele-admin-sidebox.show-divider,
.layout-card-style.ele-admin-layout.ele-pro-layout.layout-mix-card-style
  > .ele-admin-main
  > .ele-admin-side
  > .ele-admin-sidebox.show-divider {
  border-top-right-radius: 0 !important;
  border-bottom-right-radius: 0 !important;
}

.layout-card-style.ele-admin-layout.ele-pro-layout.layout-mix-card-style
  > .ele-admin-side
  > .ele-admin-sidebox
  + .ele-admin-sidebar,
.layout-card-style.ele-admin-layout.ele-pro-layout.layout-mix-card-style
  > .ele-admin-main
  > .ele-admin-side
  > .ele-admin-sidebox
  + .ele-admin-sidebar {
  border-top-left-radius: 0 !important;
  border-bottom-left-radius: 0 !important;
}

.layout-card-style.ele-admin-layout.ele-pro-layout.layout-mix-card-style
  > .ele-admin-side
  > .ele-admin-sidebar:first-child,
.layout-card-style.ele-admin-layout.ele-pro-layout.layout-mix-card-style
  > .ele-admin-main
  > .ele-admin-side
  > .ele-admin-sidebar:first-child {
  margin-left: 14px;
}

/* 悬浮多列菜单 */
.layout-grid-menu-style.ele-menu-pop {
  --ele-menu-group-color: var(--ele-color-primary);
  --ele-menu-group-dark-color: var(--ele-color-primary);
  --ele-menu-group-primary-color: #fff;
}

.layout-grid-menu-style.ele-menu-pop > .ele-menu-child {
  display: flex;
  flex-flow: column wrap;
  gap: 0px 22px;
  padding: 8px 10px;
}

.layout-grid-menu-style.ele-menu-pop > .ele-menu-child > .ele-menu-item {
  width: 180px;
}

.layout-grid-menu-style.ele-menu-pop
  > .ele-menu-child
  > .ele-menu-item.is-group
  > .ele-menu-element {
  border-bottom: 1px solid hsla(0, 0%, 66%, 0.26);
  padding-bottom: 6px;
  padding-top: 10px;
}

.layout-grid-menu-style.ele-menu-pop
  > .ele-menu-child
  > .ele-menu-item.is-group
  > .ele-menu-element
  .ele-menu-item-icon {
  margin: 0 4px 0 0;
}

.layout-grid-menu-style.ele-menu-pop
  > .ele-menu-child
  > .ele-menu-item.is-group
  > .ele-menu-element::before {
  content: '';
  width: 4px;
  height: 12px;
  border-radius: 2px;
  margin: 0 8px 0 -8px;
  background: currentColor;
}

/* 双列菜单 */
.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse),
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse) {
  --ele-menu-child-bg: hsla(0, 0%, 60%, 0.08);
  --ele-menu-dark-child-bg: rgba(255, 255, 255, 0.08);
  --ele-menu-primary-child-bg: rgba(255, 255, 255, 0.16);
  --ele-menu-group-child-bg: hsla(0, 0%, 60%, 0.08);
  --ele-menu-dark-group-child-bg: rgba(255, 255, 255, 0.08);
  --ele-menu-primary-group-child-bg: rgba(255, 255, 255, 0.16);
  --ele-menu-item-hover-color: var(--ele-color-primary);
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-element,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-element {
  pointer-events: none;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-element
  .ele-menu-item-icon,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-element
  .ele-menu-item-icon {
  margin: 0 8px 0 -8px;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-element
  .ele-menu-item-arrow,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-element
  .ele-menu-item-arrow {
  display: none;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-child,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-child {
  display: grid !important;
  transition: none;
  overflow: hidden;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent,
.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group {
  grid-column: 1/-1;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-child,
.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  > .ele-menu-child,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  > .ele-menu-child,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  > .ele-menu-child {
  border-radius: var(--ele-border-radius-base);
  margin-left: 8px;
  margin-right: 8px;
  padding: 6px 8px;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group,
.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group {
  grid-column: 1/-1;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group
  > .ele-menu-element,
.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group
  > .ele-menu-element,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group
  > .ele-menu-element,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group
  > .ele-menu-element {
  border-bottom: 1px solid hsla(0, 0%, 66%, 0.08);
  padding-bottom: 6px;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group
  > .ele-menu-child,
.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group
  > .ele-menu-child,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group
  > .ele-menu-child,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group
  > .ele-menu-child {
  display: grid;
  grid-template-columns: repeat(2, 1fr);
  grid-gap: 0 var(--ele-menu-item-margin);
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group
  > .ele-menu-child::before,
.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group
  > .ele-menu-child::after,
.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group
  > .ele-menu-child::before,
.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group
  > .ele-menu-child::after,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group
  > .ele-menu-child::before,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-parent
  .ele-menu-item.is-group
  > .ele-menu-child::after,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group
  > .ele-menu-child::before,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  > .ele-menu-item.is-group
  .ele-menu-item.is-group
  > .ele-menu-child::after {
  display: none;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item:not(.is-parent):not(.is-group),
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item:not(.is-parent):not(.is-group) {
  overflow: hidden;
}

.layout-grid-menu-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item:not(.is-parent):not(.is-group)
  > .ele-menu-element
  .ele-menu-item-badge,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item:not(.is-parent):not(.is-group)
  > .ele-menu-element
  .ele-menu-item-badge {
  position: absolute;
  top: 2px;
  right: 2px;
  margin: 0;
}

/* 网格菜单 */
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse) {
  display: grid;
  grid-template-columns: repeat(3, 1fr);
}

.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)::before,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)::after {
  display: none;
}

.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item.is-parent
  .ele-menu-item.is-group
  > .ele-menu-child,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item.is-group
  .ele-menu-item.is-group
  > .ele-menu-child {
  grid-template-columns: repeat(3, 1fr);
}

.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item.is-parent
  > .ele-menu-element
  .ele-menu-item-icon,
.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item.is-group
  > .ele-menu-element
  .ele-menu-item-icon {
  color: inherit;
  background: none;
  width: auto;
  height: auto;
  font-size: inherit;
  margin: -0.68px 6px 0 -6px;
}

.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item:not(.is-parent):not(.is-group)
  > .ele-menu-element {
  height: auto;
  line-height: 1.5;
  flex-direction: column;
  padding: var(--ele-menu-compact-item-padding);
  border-radius: var(--ele-border-radius-base);
}

.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item:not(.is-parent):not(.is-group)
  > .ele-menu-element
  .ele-menu-item-title {
  font-size: var(--ele-menu-compact-font-size);
  margin: var(--ele-menu-compact-title-margin) 0 0 0;
  max-width: 100%;
}

.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item:not(.is-parent):not(.is-group)
  > .ele-menu-element
  .ele-menu-item-icon {
  margin-left: 0;
  margin-right: 0;
}

.layout-grid-compact-style.ele-menu-bar:not(.is-menu-collapse)
  .ele-menu-item:not(.is-parent):not(.is-group)
  > .ele-menu-element::after {
  display: none;
}

/* 主题配置提示 */
.ele-theme-setting-tip {
  display: flex;
  position: absolute;
  top: 50%;
  left: 50%;
  width: 26px;
  height: 26px;
  margin: -13px 0 0 -13px;
  pointer-events: none;
}

.ele-theme-setting-tip > div {
  position: absolute;
  top: 36px;
  right: -10px;
  height: 34px;
  width: 152px;
  border-radius: 8px;
  box-sizing: border-box;
  background: var(--ele-bg-color);
  box-shadow: var(--ele-box-shadow-light);
  line-height: 18px;
  font-size: 13px;
  color: var(--ele-text-color-primary);
  padding: 8px 8px 0 14px;
}

.ele-theme-setting-tip > div > svg {
  position: absolute;
  inset: 0;
}

/* 主题抽屉常用布局封面修改 */
html.ele-theme-transparent
  .ele-setting-layout-list:not(.ele-setting-skin-list)
  .ele-setting-layout-item-cover
  .ele-setting-layout-cover-bg-dark,
html.ele-theme-transparent
  .ele-setting-layout-list:not(.ele-setting-skin-list)
  .ele-setting-layout-item-cover
  .ele-setting-layout-cover-bg-primary,
html.ele-theme-simple
  .ele-setting-layout-list:not(.ele-setting-skin-list)
  .ele-setting-layout-item-cover
  .ele-setting-layout-cover-bg-dark,
html.ele-theme-simple
  .ele-setting-layout-list:not(.ele-setting-skin-list)
  .ele-setting-layout-item-cover
  .ele-setting-layout-cover-bg-primary,
html.ele-theme-simple-dark
  .ele-setting-layout-list
  .ele-setting-layout-item-cover
  .ele-setting-layout-cover-bg-dark,
html.ele-theme-simple-dark
  .ele-setting-layout-list
  .ele-setting-layout-item-cover
  .ele-setting-layout-cover-bg-primary {
  background: var(--ele-bg-color);
}

.ele-theme-transparent .ele-setting-layout-list .ele-setting-layout-item-cover {
  background: var(--ele-fill-color-extra-light);
}

/* 卡片页签内容顶部间距适配 iframe */
.ele-admin-tabs.is-button + .ele-admin-wrapper > .ele-admin-iframe-wrap {
  top: calc(var(--ele-layout-button-tab-page-pt) - 14px);
}

.ele-admin-header.is-ghost
  + .ele-admin-body
  > .ele-admin-wrapper
  > .ele-admin-iframe-wrap,
.ele-admin-header.is-ghost
  + .ele-admin-main
  > .ele-admin-body
  > .ele-admin-wrapper
  > .ele-admin-iframe-wrap {
  top: calc(var(--ele-layout-ghost-header-page-pt) - 14px);
}

/* 菜单图标 */
.ele-icon > .layui-icon {
  font-size: inherit;
}
